use std::env;

use serenity::async_trait;
use serenity::model::channel::Message;
use serenity::model::gateway::Ready;
use serenity::prelude::*;
use tokio::fs::{read_to_string, File};

use std::fs::File as fsFile;
use std::io::prelude::*;
use std::fs::OpenOptions;
use rand::Rng;

struct Handler;

#[async_trait]
impl EventHandler for Handler {
    async fn message(&self, ctx: Context, msg: Message) {
        if msg.content.starts_with("-addquote") {   
            let quote = msg.content.strip_prefix("-addquote ").expect("asdf").to_string().replace("@", "\\@\\");
            let quote_to_write = format!("{}", quote).clone();
            let mut quote_file = OpenOptions::new().write(true).append(true).open("quotes.txt").unwrap();
            let write_result = writeln!(quote_file, "{}", quote_to_write);
        
            match write_result {
                Ok(_) => {
                    if let Err(_) = msg.channel_id.say(&ctx.http, "Successfully added your quote!").await {
                        println!("THIS IS BROKJEN.");
                    }
                },
                Err(e) => {
                    if let Err(_) = msg.channel_id.say(&ctx.http, "fuck.").await {
                        println!("EVERYTHING IS BREAKING.");
                    }
                    println!("STUPID FUCKING FILE: {}", e);
                }
            }
        } else if msg.content.starts_with("-quote") {
            let mut result = Vec::new();

            for line in read_to_string("quotes.txt").await.unwrap().lines() {
                result.push(line.to_string())
            }

            let rando = rand::rng().random_range(0..result.len());

            if let Err(_) = msg.channel_id.say(&ctx.http, result[rando].to_string()).await {
                println!("mfw");
            }


        }
    }

    async fn ready(&self, _: Context, ready: Ready) {
        println!("{} is connected!", ready.user.name);
    }
}
    
#[tokio::main]
async fn main() {
    fsFile::create_new("quotes.txt");
    let token = std::fs::read_to_string("token.txt").expect("Can't read token.txt file!");
    let intents = GatewayIntents::GUILD_MESSAGES
        | GatewayIntents::DIRECT_MESSAGES
        | GatewayIntents::MESSAGE_CONTENT;

    let mut client =
        Client::builder(&token, intents).event_handler(Handler).await.expect("Err creating client");

    if let Err(why) = client.start().await {
        println!("Client error: {why:?}");
    }
}